<script lang="ts">
  import Section from '$lib/components/sections/Section.svelte';
  import Tag from '$lib/components/Tag.svelte';
  import BaseLayout from '$lib/components/layouts/BaseLayout.svelte';
  import ProjectCard from '$lib/components/cards/ProjectCard.svelte';
  import type { PageData } from './$types';
  import { axiosInstance } from '$lib/config';
  import Pagination from '$lib/components/Pagination.svelte';

  export let data: PageData;

  let projects = data?.project.data,
    page = data.page || 1,
    pages = data?.project.pages;

  $: {
    projects = data?.project.data;
    page = data.page || 1;
    pages = data?.project.pages;
  }

  async function handleSearch(event: any) {
    const res = await axiosInstance.get('/project', { params: { ...(event.detail && { name: event.detail }) } });

    if (event.detail) {
      pages = 0;
    } else {
      pages = data?.project.pages;
    }

    projects = res.data.data;
  }
</script>

<svelte:head>
    <title>Научные проекты студентов</title>
</svelte:head>

<BaseLayout>
    <Section title="Научные проекты студентов" class="mt-16" {handleSearch}>
<!--        <section class="space-y-6">-->
<!--            <p class="text-4xl font-serif">Категории</p>-->
<!--            <section class="flex flex-wrap gap-3">-->
<!--                {#each categories as { name, href }}-->
<!--                    <a {href}>-->
<!--                        <Tag {name}/>-->
<!--                    </a>-->
<!--                {/each}-->
<!--            </section>-->
<!--        </section>-->
        <section class="grid 2xl:grid-cols-3 lg:grid-cols-2 gap-8">
            {#each projects as { id, name, description, attachment, tagProject: tags }}
                <ProjectCard
                    {id}
                    {name}
                    {description}
                    {attachment}
                    {tags}
                />
            {/each}
        </section>
        <Pagination {page} {pages}/>
    </Section>
</BaseLayout>